define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "thornberry/app/Component/_Component",
    "thornberry/app/Component/_EditorViewMixin",
    "thornberry/app/Component/BillingCharges/ChargeEditor",
    "thornberry/serverRequest",
    "thornberry/app/utils"
],function(
    declare,
    lang,
    Component,
    _EditorViewMixin,
    ChargeEditor,
    serverRequest,
    utils
) {
    return declare([Component,_EditorViewMixin],{
        title: "Charge",

        EditorClass: ChargeEditor,
        lockCheckEnabled: true,
        objectType: "Billing.Charge.Abstract",

        objectId: "",
        charge: null,

        getPageProps: function() {
            var t = this;
            return lang.mixin(t.inherited(arguments),{
                accountSummaryShown: t.props.objectId !== "",
                ndocNum: t.charge && t.charge.ndocNum
            });
        },

        refreshRendering: function() {
            var t = this;
            if (t.isShown) {
                t.set("objectId",t.props.objectId);

                t.editor.set("props",{
                    value: t.charge,
                    mode: (t.props.objectId == "" ? "add" : "edit"),
                    disabled: (t.props.mode === "view")
                });
            }
            t.inherited(arguments);
        },

        _setObjectIdAttr: function(value) {
            var t = this;
            if (value != t.objectId) {
                t.objectId = value;
                if (t.objectId != "") {
                    var promise = serverRequest("Billing.Charge.Medication","GetJson",t.objectId).then(function(charge) {
                        t.set("charge",charge);
                    },utils.showMessage);
                    t.addReadyPromise(promise);
                } else {
                    t.set("charge",null);
                }
            }
        },

        _setChargeAttr: function(value) {
            var t = this;
            if (t.charge !== value) {
                t.charge = value;
                t.editor.set("props",{
                    value: value
                });
                t.setPageProps();
            }
        },

        save: function() {
            var t = this;
            var data = lang.mixin(t.editor.get("value"),{
                id: t.props.objectId
            });
            return serverRequest("Billing.Charge.Medication","SaveJson",data).then(function() {
                t.objectId = null; // Force the editor to reload the object if the same object is edited immediately after
                t.props.onSave();
            });
        }
    });
});