define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "thornberry/app/Component/_Component",
    "thornberry/app/Component/_ViewMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/text!./Templates/FileUploadView.html",
    "thornberry/app/fileUpload",
    "thornberry/app/utils",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/on",
    "dojo/dom",
    "dijit/form/Button",
    "dojo/has",
    "dojo/sniff",
    "dijit/form/TextBox"
],function(
    declare,
    lang,
    _Component,
    _ViewMixin,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    template,
    fileUpload,
    utils,
    domConstruct,
    domStyle,
    on,
    dom,
    Button,
    has
) {
    // Drag-and-drop files from the file system for IE-10+ is not implemented fully

    return declare([_Component,_ViewMixin,_TemplatedMixin,_WidgetsInTemplateMixin],{
        templateString: template,

        selected: false,

        fileUpload: fileUpload,

        getTitle: function() {
            return this.props.title;
        },

        getInitialProps: function() {
            var t = this;
            return lang.mixin(t.inherited(arguments),{
                title: "",  
                serverClass: "",    // this and the next prop specify what code gets called with the uploaded file stream
                serverMethod: "",
                onUpload: null
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            /*if (has("id") >= 10) {
                t.overlayNode = domConstruct.toDom("<div class='fileDropOverlay' style='display:none;filter:progid:DXImageTransform.Microsoft.Alpha(Opacity=30)'></div>");
                domConstruct.place(t.overlayNode,t.domNode);
            }*/

            // Turn the upload button into a widget for display in the action area
            t.uploadButtonWidget = new (declare([_Component],{
                buildRendering: function() {
                    var self = this;
                    self.inherited(arguments);
                    self.domNode = t.uploadLabel;
                }
            }));
        },

        postCreate: function() {
            var t = this;
            t.inherited(arguments);

            // Cancel the default behavior so that the click will bubble up to the containing label, which triggers the file input from PageContainer
            t.browseButton.__onClick = function() {};
            t.uploadButton.__onClick = function() {};

            /*if (has("ie") >= 10) {
                t.own(
                    on(t.domNode,"dragover",function(event) {
                        event.preventDefault();
                        event.stopPropagation();
                        
                        domStyle.set(t.overlayNode,"display","block");
                    }),
                    on(t.overlayNode,"dragleave", function(event) {
                        event.preventDefault();
                        event.stopPropagation();
                        
                        domStyle.set(t.overlayNode,"display","none");
                        return false;
                    }),
                    on(t.overlayNode,"drop",function(event) {
                        domStyle.set(t.overlayNode,"display","none");
                            t.onDrop(event.dataTransfer.getData("text"));
                        t.domNode.focus();
                    })
                );
            }*/
        },

        getPageProps: function() {
            var t = this;
            return lang.mixin(t.inherited(arguments),{
                content: t.domNode,
                actions: [
                    { label: "Cancel", onClick: t.props.onCloseView },
                    (t.selected ? t.uploadButtonWidget : null),
                ]
            });
        },

        /*onDrop: function(files) {
            var t = this;
            t.domNode.innerHTML = files.join(",");
        },*/

        onBeforeShow: function() {
            var t = this;
            t.inherited(arguments);

            t.textBox.reset();
            t.set("selected",false);
            fileUpload.reset();
        },

        onShow: function() {
            this.uploadHandle = fileUpload.addSubscriber(this,this.props.serverClass,this.props.serverMethod);
        },

        onHide: function() {
            this.uploadHandle.remove();
        },

        onSelectFile: function(fileName) {
            var t = this;
            t.textBox.set("value",fileName);
            t.set("selected",true);
        },

        onUpload: function(result) {
            var t = this;
            if (t.props.onUpload) {
                t.props.onUpload(result);
            }
        },

        onUploadFailure: function(error) {
            utils.showMessage(error);
        },

        _setSelectedAttr: function(value) {
            var t = this;
            if (t.selected !== value) {
                t.selected = value;
                t.setPageProps();
                t.defer(function() {
                    domStyle.set(t.uploadLabel,"display",value ? "" : "none");
                });
            }
        }
    });
});