define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "thornberry/app/Component/_Component",
    "dijit/_TemplatedMixin",
    "dojo/text!./Templates/LogItem.html",
    "dojo/text!./Templates/LogItemDetail.html",
    "dojo/dom-construct",
    "dijit/registry"
],function(
    declare,
    arrayUtils,
    lang,
    _Component,
    _TemplatedMixin,
    template,
    detailTemplate,
    domConstruct,
    registry
) {
    var templates = {
        "request" : "Request Created",
        "response" : "Response Received"
    }

    var headerProps = {
        "template": true,
        "Timestamp": true,
        "Method": true
    };

    var Item = declare([_Component,_TemplatedMixin], {
        templateString: template,

        type: "",

        getInitialProps: function() {
            return {
                item: null
            }
        },

        postMixInProperties: function() {
            var t = this;
            t.inherited(arguments);

            t.type = templates[t.props.item.template];
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            for (var name in t.props.item) {
                var value = t.props.item[name];
                if (!headerProps[name] && value) {
                    t.detailContainerNode.appendChild(domConstruct.toDom(lang.replace(detailTemplate,{ name: name, value: value })));
                }
            }
        }
    });

    return declare([_Component],{
        getInitialProps: function() {
            return {
                items: []
            }
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);
            t.domNode = domConstruct.toDom("<div></div>");
        },

        refreshRendering: function() {
            var t = this;
            t.inherited(arguments);

            arrayUtils.forEach(registry.findWidgets(t.domNode),function(widget) {widget.destroy()});

            arrayUtils.forEach(t.props.items,function(item) {
                t.domNode.appendChild(new Item({ props: { item: item } }).domNode);
            });
        }
    });
})