define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "thornberry/app/component/Report/View",
],function(
    declare,
    lang,
    ReportView
) {
    return declare(ReportView,{

        settings: null,
        showPresetControl: false,

        policyId: "",

        getTitle: function() {
            return this.props.type+" History of "+this.props.summary;
        },

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                reportClass: "Billing.Report.NOENOTRHistory",
                summary: "History",
                type: "", // "NOE" or "NOTR"
                policyId: ""
            });
        },

        getPageProps: function() {
            var t = this;
            var showResponse = t.props.selectedIds.length === 1 && t.getGridData(t.props.selectedIds[0]).Status === "Response Received";

            return lang.mixin(t.inherited(arguments),{
                actions: [
                    { label: "Back", onClick: t.props.onCloseView },
                    { label: "View Response", onClick: function() { t.loadSubView("response",{ id: t.props.selectedIds[0] }); }, hidden: !showResponse }
                ],
                optionsButtonShown: false
            });
        },

        refreshRendering: function() {
            var t = this;
            if (t.props.policyId !== t.policyId) {
                t.policyId = t.props.policyId;
                t.refreshData();
            }
            t.inherited(arguments);
        },

        onShow: function() {
            var t = this;
            if (t.firstShow) {
                t.addSubView("response","thornberry/app/Component/NoeNotrTracking/ResponseView",function() {
                    return { type: t.props.type };
                });
            }
            t.inherited(arguments);
        },

        onGetContext: function(context) {
            var t = this;
            debugger;
            context.filters.push({
                column: "Policy",
                value: t.props.policyId,
                displayName: "History of",
                displayValue: t.props.summary
            });
            context.filters.push({
                column: "Type",
                value: t.props.type,
                displayName: "Type"
            });
            return context;
        }
    });
});