define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "dojo/_base/lang",
    "dojo/text!./Templates/StatusEditor.html",
    "thornberry/app/Service/NoeNotr",
    "dijit/form/DateTextBox",
    "dijit/form/Form",
    "dijit/form/Select"
],function(
    declare,
    _EditorComponent,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _TableFieldEditorMixin,
    lang,
    template,
    service
) {
    return declare([_EditorComponent,_TemplatedMixin,_WidgetsInTemplateMixin,_TableFieldEditorMixin], {
        templateString: template,

        type: "",

        statusLabel: "label",
        _setStatusLabelAttr: { node: "statusLabelNode", type: "innerText" },

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                type: "", // "NOE" or "NOTR",
                statusTable: null
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            // general logic
            t.addLogic("status",function(name,value) {
                t.setFormValue("acceptanceDate",value === 3 ? new Date() : null);
            });

            // disable logic
            t.addDisabled("acceptanceDate",function(name,data) {return data.status !== 3;});

            // requirement logic
            t.addRequirement(null,true); // All fields required

            // tables
            t.addTableFilter("status",function(name,tableItem) {
                return tableItem.name !== "Pending";
            });
        },

        refreshRendering: function() {
            var t = this;
            t.set("type",t.props.type);
            t.inherited(arguments);
        },

        _setTypeAttr: function(value) {
            var t = this;
            if (value != t.type) {
                t.type = value;
                t.set("statusLabel",lang.replace("{type} Status",{ type: value }));
                
                t._tableLoadPromise = service.getStatusTable(value).then(function(results) {
                    t.setTable("status",results);
                });
            }
        }
    });
});