define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-style",
    "thornberry/app/utils",
    "dojo/text!./Templates/GeneralEditor.html",
    "dijit/form/ValidationTextBox",
    "dijit/form/RadioButton",
    "dijit/form/DateTextBox",
    "dijit/form/Form"
],function(
    declare,
    _EditorComponent,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    lang,
    domAttr,
    domStyle,
    utils,
    template
) {
    return declare([_EditorComponent,_TemplatedMixin,_WidgetsInTemplateMixin], {
        templateString: template,

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                data: null
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            t.addValidation("medicareNum",utils.validators.policyNum("medicare"));
            t.addValidation("medicaidNum",utils.validators.policyNum("medicaid"));
            t.addValidation("rrbNum",utils.validators.policyNum("rrb"));

            t.addRequirement([
                "medicareNum",
                "medicaidNum"
            ],true);
        },

        refreshRendering: function() {
            var t = this;
            t.inherited(arguments);
            
            if (t.props.value) {
                var value = t.props.value;
                var disabled = t.props.disabled;

                domStyle.set(t.rrbNumFieldContainer,"display",(value.patientType === "hospice" ? "" : "none"));
                domAttr.set(t.medicarePrefixNode,"innerHTML",(!disabled ? (value.patientType === "homecare" ? "[M0063]" : "[A0600B]") : ""));
                domAttr.set(t.medicaidPrefixNode,"innerHTML",(!disabled ? (value.patientType === "homecare" ? "[M0065]" : "[A0700]") : ""));
                domAttr.set(t.rrbPrefixNode,"innerHTML",(!disabled && value.patientType === "hospice" ? "[A0600]" : ""));
            }
        }
    });
});