define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "thornberry/app/Component/_Component",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/dom-construct"
],function(
    declare,
    lang,
    arrayUtils,
    _Component,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    domConstruct
) {
    var Row = declare([_Component,_TemplatedMixin,_WidgetsInTemplateMixin],{
        template: 
            "<div class='content-flex-container app-component-scorecard-row' data-dojo-attach-event='onclick:_click'>{rowTemplate}</div>",

        getInitialProps: function() {
            var t = this;
            return lang.mixin(t.inherited(arguments),{
                onClick: null,
                item: null,
                getDisplayValue: null
            });
        }, 

        postMixInProperties: function() {
            var t = this;
            t.inherited(arguments);

            t.templateString = lang.replace(t.template,t.props);

            if (t.props && t.props.item) {
                var item = t.props.item;
                var displayValues = {};
                for (key in item) {
                    item[key] = t.props.getDisplayValue ? t.props.getDisplayValue(key,item[key]) : item[key];
                }
            }
        },

        _click: function() {
            var t = this;
            if (t.props.onClick) {
                t.props.onClick(t.props.item.id);
            }
        }
    });

    return declare([_Component,_TemplatedMixin,_WidgetsInTemplateMixin],{
        title: "Score Card",

        templateString: 
            "<div class='content-area app-component-scorecard'>"+
                "<div class='content-area-title'>"+
                    "<a style='font-family:Verdana, Geneva, sans-serif; margin-left:8px' class='content-area-title-text' data-dojo-attach-event='onclick:_onClickTitle'>${title}</a>"+
                "</div>"+
                "<div class='content-divider'></div>"+
                "<div data-dojo-attach-point='itemContainer'></div>"+
            "</div>",

            getInitialProps: function() {
                var t = this;
                return lang.mixin(t.inherited(arguments),{
                    onClickTitle: null,
                    onClickRow: null,
                    rowTemplate: "<div></div>"
                });
            }, 

            refreshRendering: function() {
                var t = this;
                domConstruct.empty(t.itemContainer);

                if (t.props.data) {
                    arrayUtils.forEach(t.props.data,function(item) {
                        t.itemContainer.appendChild(new Row({
                            props: {
                                item: item,
                                rowTemplate: t.props.rowTemplate,
                                getDisplayValue: t.props.getDisplayValue,
                                onClick: function(rowId) {
                                    if (t.props.onClickRow) {
                                        t.props.onClickRow(rowId);
                                    }
                                }
                            }
                        }).domNode);
                    });
                }
            },

            _onClickTitle: function() {
                var t = this;
                if (t.props.onClickTitle) {
                    t.props.onClickTitle();
                }
            }
    });
});