define([
    "thornberry/serverRequest",
    "dojo/Deferred"
],function(
    serverRequest,
    Deferred
) {
    /*
        How to use (handler class extends UI.EnsembleRequest):

        require(["thornberry\app\Service\EnsembleRequest"],function(factory) {
            var service = factory({handler class});
            var promise = service(options,360);
            promise.then(
                function(result) {},
                function(errorMessage) {},
                function(updateMessage) {}
            );
        });
    */ 
    return function(cacheClass) {
        var createRequest = function(options) {
            return serverRequest(cacheClass,"CreateRequest",options);
        };
        var getRequestStatus = function(requestId) {
            return serverRequest(cacheClass,"GetRequestStatus",requestId);
        };
        var awaitRequestData = function(options) {
            return serverRequest(cacheClass,"AwaitRequestData",options,true);
        };

        var watchRequest = function(promise) {
            var message = submitResult.message;
            var handle = submitResult.handle;
            var requestId = submitResult.requestId;

            deferred.progress(message);

            awaitRequestData({requestId:requestId,handle:handle,timeout:timeout}).then(deferred.resolve,deferred.reject);
            
            var checkStatusLoop = function() {
                setTimeout(function() {
                    if (!deferred.isFulfilled()){
                        getRequestStatus(requestId).then(function(status) {
                            if (status) {
                                deferred.progress(status);
                            }
                            checkStatusLoop();
                        },deferred.reject);
                    }
                },1000)
            };
            checkStatusLoop();
        }

        return function(/*options or promise*/options,/* seconds */timeout) {
            var deferred = new Deferred;
            var promise = (options.then ? options : createRequest(options));
            promise.then(function(submitResult) {
                var message = submitResult.message;
                var handle = submitResult.handle;
                var requestId = submitResult.requestId;

                deferred.progress(message);

                awaitRequestData({requestId:requestId,handle:handle,timeout:timeout}).then(deferred.resolve,deferred.reject);
                
                var checkStatusLoop = function() {
                    setTimeout(function() {
                        if (!deferred.isFulfilled()){
                            getRequestStatus(requestId).then(function(status) {
                                if (status) {
                                    deferred.progress(status);
                                }
                                checkStatusLoop();
                            },deferred.reject);
                        }
                    },1000)
                };
                checkStatusLoop();
            },deferred.reject);

            return deferred.promise;
        };
    };
});