define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "thornberry/serverRequest",
    "dojo/Deferred"
],function(
    declare,
    lang,
    serverRequest,
    Deferred
) {
    var CACHE_CLASS = "Billing.Eligibility.Service";

    var InsuranceEligibilityService = declare(null,{
        setRequestDownloaded: function(requestId) {
            return serverRequest(CACHE_CLASS,"SetRequestDownloaded",requestId);
        },
        getResponses: function(policyIds) {
            return serverRequest(CACHE_CLASS,"GetResponses",policyIds);
        },
        processResponses: function(responseIds,deletedIds) {
            return serverRequest(CACHE_CLASS,"ProcessResponses",{
                responseIds:responseIds,
                deletedIds:deletedIds
            });
        }
    },true);
    return new InsuranceEligibilityService(); // Singleton
});